#include <avr/io.h>
#include "config.h"
#include <stdlib.h>

.global W20msReadADC
.global W5msReadADC
.global ReadADC

// ANZ_MES = 44 fr hchste Genauigkeit, Summe von 44 einzelne Messungen
// ANZ_MES = 22 fr mittlere Genauigkeit, 22 einzelne Messungen, Ergebnis wird zustzlich mit 2 multipliziert
// ANZ_MES = 11 fr hchste Geschwindigkeit, 11 einzelne Messungen, Ergebnis wird mit 4 multipliziert
// Durch die anschliessende Division durch 9 wird jeweils eine mV Auflsung erreicht.
// Die schnellste Variante braucht aber zustzlich 4 Befehle (8 Byte)

;.equ ANZ_MES,44
#define ANZ_MES 44

#undef ADCSRA
#define ADCSRA 0x06
#undef ADMUX
#define ADMUX 0x07

W20msReadADC:
  rcall	wait20ms
  rjmp	ReadADC

W5msReadADC:
  rcall	wait5ms

;//unsigned int ReadADC(uint8_t mux)
; { //ADC-Wert des angegebenen Kanals auslesen und als unsigned int zurckgegen
ReadADC:
;  ADMUX = mux | (1<<REFS0);
  ori	r24,0x40
  out	ADMUX,r24
;  unsigned int adcx = 0;
  ldi	r24,0x00
  ldi	r25,0x00

;  for(uint8_t j=0;j<ANZ_MESS;j++)
  ldi   r20,0x00
;    {	//ANZ_MESS Messungen; fr bessere Genauigkeit
;     ADCSRA |= (1<<ADSC);		//starte Conversion
   sbi	ADCSRA,ADSC	
;     while (ADCSRA&(1<<ADSC));		//warte
lop1:
  sbic	ADCSRA,ADSC
  rjmp	lop1


;     adcx += ADCW;
//  in	r18,ADCL; 
//  in	r19,ADCH; 
  in	r18,0x04; 
  in	r19,0x05; 
  add	r24,r18
  adc	r25,r19

  inc   r20
  cpi   r20,ANZ_MES
  brne	lop1
;  return adcx/9
#if ANZ_MES == 11
  add	r24,r24		;*2
  adc	r25,r25
  add	r24,r24		;*2
  adc	r25,r25
#endif
#if ANZ_MES == 22
  add	r24,r24		;*2
  adc	r25,r25
#endif
  ldi	r22,9
  ldi	r23,0
  rcall __udivmodhi4 	; dividiere r24,r25 durch r22,r23 (9)
  movw	r24, r22	; Ergebnis in r22,r23
  ret

